if(!isObject(BossBattlesGUI))
{
	new GuiControlProfile(BBGUI_TextProfile)
	{
		fontColor = "0 0 0 255";
		fontType = "Arial";
		fontSize = "14";
		justify = "Left";
		fontColors[1] = "255 0 0 255";
		fontColors[2] = "0 255 0 255";  
		fontColors[3] = "0 0 255 255"; 
		fontColors[4] = "127 0 0 255"; 
		fontColors[5] = "255 255 0 255";
		fontColors[6] = "255 0 255 255";
		fontColorLink = "255 96 96 255";
		fontColorLinkHL = "0 0 255 255";
	};
	exec("./BBGUI.gui");
	BB_HUDFont.setActive(false);
}


$BBGUIVersion = 3.5;
if($Pref::Client::BossBattles::HUD_Font $= "")
	$Pref::Client::BossBattles::HUD_Font = "arial";

if($Pref::Client::BB_HUDImage $= "")
	$Pref::Client::BB_HUDImage = "barFull";

if($Pref::Client::BB_HUDImageWrap $= "")
	$Pref::Client::BB_HUDImageWrap = true;

if($pref::Client::BossBattlesGUI::EnableDoubleBoss $= "")
	$pref::Client::BossBattlesGUI::EnableDoubleBoss = true;

BB_HudDoubleBoss.setValue($pref::Client::BossBattlesGUI::EnableDoubleBoss);

//addClass - Registers a class script object for use with the GUI.
function BossBattlesGUI::addClass(%this, %name, %dispName, %descript, %group, %health, %speed, %other, %price, %item1, %item2, %item3, %item4, %item5)
{
	if(!isObject(BossBattlesClassGroup))
	{
		new simGroup(BossBattlesClassGroup);
		ServerConnection.add(BossBattlesClassGroup); //Put it somewhere that I don't have to worry about deleting it later.
	}
	if(isObject(%existing = "BossBattlesClass_" @ %name))
		%existing.delete();
	%playerClass = new ScriptObject("BossBattlesClass_" @ %name)
	{
		realName = %name;
		name = %dispName;
		description = %descript;
		group = %group;
		health = %health;
		speed = %speed;
		price = %price;
		otherString = %other;
		item[1] = %item1;
		item[2] = %item2;
		item[3] = %item3;
		item[4] = %item4;
		item[5] = %item5;
	};
	BossBattlesClassGroup.add(%playerClass);
}

//setBlocker - Helper method for enabling and disabling blockers.
function BossBattlesGUI::setBlocker(%this, %index, %value)
{
	switch(%index)
	{
		case 0:
			%obj = BBGUI_BlockerPlay;
		case 1:
			%obj = BBGUI_BlockerType1;
		case 2:
			%obj = BBGUI_BlockerType2;
		case 3:
			%obj = BBGUI_BlockerType3;
		case 4:
			%obj = BBGUI_BlockerType4;
		//case 5:
		//	%obj = BBGUI_BlockerAkimbo;
		//case 6:
		//	%obj = BBGUI_BlockerLife;
		default:
			return;
	}
	switch(%value)
	{
		case 0: //Enable the button.
			%obj.setVisible(0);
		case 1: //Disable the button.
			%obj.setVisible(1);
			%obj.setColor("200 200 200 200");
		case 2: //Hide the button.
			%obj.setVisible(1);
			%obj.setColor("200 200 200 255");
	}
}

//loadClassGroup - loads all classes from a group into the class list.
function BossBattlesGUI::loadClassGroup(%this, %group)
{
	if(!isObject(BossBattlesClassGroup))
		return;
	BBGUI_ClassList.clear();
	%count = BossBattlesClassGroup.getCount();
	%classCount = 0;
	for(%i = 0; %i < %count; %i++)
	{
		%playerclass = BossBattlesClassGroup.getObject(%i);
		if(%playerclass.group != %group)
			continue;
		BBGUI_ClassList.classObj[%i] = %playerclass; //To easily translate an ID back into a class.
		BBGUI_ClassList.addRow(%i, %playerclass.name);
	}
	BBGUI_ClassList.sort(0, true);
}

//selectClass - Dispalys a class's stats on the GUI.
function BossBattlesGUI::selectClass(%this, %obj)
{
	if(!isObject(%obj))
	{
		BBGUI_ClassName.setText("<font:impact:25>No class");
		BBGUI_ClassDescript.setText("No class has been selected.");
		BBGUI_ClassHealth.setText("Health: ");
		BBGUI_ClassSpeed.setText("Speed: ");
		BBGUI_ClassPrice.setText("");
		BBGUI_ClassItems.setText("Items: ");
		BBGUI_ClassOther.setText("Other: ");
		BBGUI_InfoText.setText(%this.infoString);
		%this.setBlocker(0, 1);
		%this.currClass = 0;
		return;
	}
	switch(%obj.group)
	{
		case 1:
			%groupString = "<color:ffff00>Class";
		case 2:
			%groupString = "<color:EC7000>Miniboss";
		case 3:
			%groupString = "<color:ff0000>Boss";
		case 4:
			%groupString = "<color:ff00ff>Special";
		default:
			%groupString = "<color:000000>Class";
	}
	BBGUI_ClassName.setText("<font:impact:25>" @ %groupString @ "<color:000000>: " @ %obj.name);
	BBGUI_ClassDescript.setText(%obj.description);
	BBGUI_ClassHealth.setText("Health: " @ %obj.health);
	BBGUI_ClassSpeed.setText("Speed: " @ %obj.speed);
	if(%obj.price > 0)
	{
		%priceColor = (%this.currScore < %obj.price) ? "\c1" : "\c0";
		BBGUI_ClassPrice.setText(%priceColor @ "Price: " @ %obj.price);
	}
	else
		BBGUI_ClassPrice.setText("");
	%itemString = "Items: ";
	for(%i = 1; %i <= 5; %i++)
		if(%obj.item[%i] !$= "")
			%itemString = %itemString NL %obj.item[%i];
	BBGUI_ClassItems.setText(%itemString);
	BBGUI_ClassOther.setText("Other: " @ %obj.otherString);
	%this.currClass = %obj;
	%this.updateInfoString();
}

//onSelect - Called upon clicking a class in the list.
function BBGUI_ClassList::onSelect(%this, %id)
{
	//%id = BBGUI_ClassList.getId();
	%this.currClass[BossBattlesGUI.currGroup] = %id;
	if(%id == -1)
		BossBattlesGUI.selectClass(0);
	else
		BossBattlesGUI.selectClass(%this.classObj[%id]);
}

//onPickGroup - Called upon clicking one of the class buttons.
function BossBattlesGUI::onPickGroup(%this, %group)
{
	%this.loadClassGroup(%group);
	%this.currGroup = %group;
	if(BBGUI_ClassList.classObj[BBGUI_ClassList.currClass[%this.currGroup]].group != %group)
		BBGUI_ClassList.onSelect(-1);
	else
		BBGUI_ClassList.setSelectedByID(BBGUI_ClassList.currClass[%this.currGroup]);
}

function BossBattlesGUI::onClickPlay(%this)
{
	%selectedClass = BBGUI_ClassList.classObj[BBGUI_ClassList.currClass[%this.currGroup]];
	if(isObject(%selectedClass))
		commandToServer('SelectClass', %selectedClass.realName);
}

//onWake - Called when the GUI opens.
function BossBattlesGUI::onWake(%this)
{
	if(!%this.currGroup)
		%this.currGroup = 1;
	if(%this.currGroup == 3 && BBGUI_BlockerType3.isVisible() || %this.currGroup == 4 && BBGUI_BlockerType4.isVisible())
		%this.currGroup = 1;
	if(%this.currGroup == 1 && BBGUI_BlockerType1.isVisible() || %this.currGroup == 2 && BBGUI_BlockerType2.isVisible())
		%this.currGroup = 3;
	%this.onPickGroup(%this.currGroup);
}

//newRound - Resets values for a new round.
function BossBattlesGUI::newRound(%this)
{
	%this.minibossFull = 0;
	%count = BossBattlesClassGroup.getCount();
	for(%i = 0; %i < %count; %i++)
	{
		%playerclass = BossBattlesClassGroup.getObject(%i);
		%playerClass.errorFull = 0;
	}
}

//updateInfoString - Sets the info string to an error if there is one, or the given string otherwise.
function BossBattlesGUI::updateInfoString(%this)
{
	%obj = %this.currClass;
	if(isObject(%obj))
	{
		if(%obj.error !$= "")
			%errorString = %obj.error;
		else if(%this.currScore < %obj.price && %obj.price > 0)
			%errorString = "\c1Error: You don't have enough points to afford this class.";
		else if(%obj.errorFull == 1)
			%errorString = "\c1Error: This class has been taken this round.";
		else if(%obj.errorFull > 1)
			%errorString = "\c1Error: This class is full to capacity this round.";
		else if(%this.minibossFull && %obj.group == 2)
			%errorString = "\c1Error: Miniboss capacity reached this round.";
	}
	if(%errorString $= "")
	{
		BBGUI_InfoText.setText(%this.infoString);
		%this.setBlocker(0, 0);
	}
	else
	{
		BBGUI_InfoText.setText(%errorString);
		%this.setBlocker(0, 1);
	}
}

//clientCmdBBGUI - Huge function for all client commands.
function clientCmdBBGUI(%action, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10, %a11, %a12, %a13) //Cramming this all into one function.
{
	%gui = BossBattlesGUI;
	%list = BBGUI_ClassList;
	switch$(%action)
	{
		case "handshake": //So I don't have to package anything to see if it's the Boss Battles server.
			commandToServer('BBGUIHandshake', $BBGUIVersion);
			$enableBBHud = true;
		case "setScore": //Sets the score shown on the points label.
			%gui.currScore = %a1;
			BBGUI_Score.setText("Points: " @ %a1);
			if(%gui.currClass.price > 0)
				%gui.updateInfoString();
		case "wakeGUI": //Opens the GUI.
			canvas.pushDialog(%gui);
			if(newMessageHud.isAwake())
			{
				canvas.popDialog(newMessageHud);
				canvas.pushDialog(newMessageHud);
			}
		case "closeGUI": //Closes the GUI.
			canvas.popDialog(%gui);
		case "addClass":
			%gui.addClass(%a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10, %a11, %a12, %a13);
			if(%gui.isAwake() && %gui.currGroup == %a4)
				%gui.onPickGroup(%gui.currGroup);
		case "setTeam": //Fast way to set the button blockers.
			switch(%a1)
			{
				case 0: //Normals team
					%gui.setBlocker(1, 0);
					%gui.setBlocker(2, 2);
					%gui.setBlocker(3, 1);
					%gui.setBlocker(4, 2);
					%gui.setBlocker(5, 2);
					%gui.setBlocker(6, 2);
					if(%gui.currGroup > 2)
						%gui.currGroup = 1;
				case 1: //Boss team
					%gui.setBlocker(1, 1);
					%gui.setBlocker(2, 2);
					%gui.setBlocker(3, 0);
					%gui.setBlocker(4, 2);
					%gui.setBlocker(5, 2);
					%gui.setBlocker(6, 2);
					%gui.currGroup = 3;
				case 2: //Normals exclusive team
					%gui.setBlocker(1, 0);
					%gui.setBlocker(2, 2);
					%gui.setBlocker(3, 1);
					%gui.setBlocker(4, 2);
					%gui.setBlocker(5, 2);
					%gui.setBlocker(6, 2);
					%gui.currGroup = 1;
				case 3: //Mini-boss exclusive team
					%gui.setBlocker(1, 1);
					%gui.setBlocker(2, 0);
					%gui.setBlocker(3, 1);
					%gui.setBlocker(4, 2);
					%gui.setBlocker(5, 2);
					%gui.setBlocker(6, 2);
					%gui.currGroup = 2;
				case 4: //Debug team
					%gui.setBlocker(1, 0);
					%gui.setBlocker(2, 0);
					%gui.setBlocker(3, 0);
					%gui.setBlocker(4, 0);
					%gui.setBlocker(5, 2);
					%gui.setBlocker(6, 2);
			}
		case "setBlockers": //Manual way to adjust button blockers.
			if(%a3 !$= "")
			{
				%gui.setBlocker(1, %a1);
				%gui.setBlocker(2, %a2);
				%gui.setBlocker(3, %a3);
				%gui.setBlocker(4, %a4);
				%gui.setBlocker(5, %a5);
				%gui.setBlocker(6, %a6);
			}
			else
				%gui.setBlocker(%a1, %a2);
		case "setInfoString": //Sets the message telling who the boss is.
			switch(%a1)
			{
				case 0:
					%gui.infoString = "";

				case 1:
					%num = %gui.bossCount;

					%gui.infoString = "Current boss: \c1" @ %a2 @ "\c0 as \c1" @ %a3 @ "\c0.";
					if(BB_HudPos.getText() !$= "Off")
						BB_HUD.setVisible(1);

					%gui.SetBossInfo(%num, %a2, %a3);

					%gui.bossCount++;
					BB_Hud_resize();

				case 2:
					%gui.bossPlayerName[0] = %a2;
					%gui.bossPlayerClass[0] = "";
					%gui.infoString = "Current boss: \c1" @ %a2 @ "\c0 is choosing a class.";
					BB_BossName1.setText("<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":25>\c1Boss");
					BB_BossHealthText1.setText("<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":20><color:B3B3B3>Health: 100%");
					BB_Hud_resize();

				case 3:
					%gui.infoString = %a2;
			}

			%gui.updateInfoString();

		case "setMinibossFull": //Sets a variable determining if the minibosses are full to capacity.
			%gui.minibossFull = %a1;
			%gui.updateInfoString();

		case "setClassFull": //Sets whether a class is full. Can use a value greater than 1 to display a plural error.
			%classObject = "BossBattlesClass_" @ %a1;
			if(!isObject(%classObject))
				return;
			%classObject.errorFull = %a2;
			%gui.updateInfoString();

		case "setClassError": //Sets a general error for a class.
			%classObject = "BossBattlesClass_" @ %a1;
			if(!isObject(%classObject))
				return;
			%classObject.error = %a2;
			%gui.updateInfoString();

		case "removeClass": //Deletes a class.
			%classObject = "BossBattlesClass_" @ %a1;
			if(!isObject(%classObject))
				return;
			%group = %classObject.group;
			%classObject.delete();
			if(%gui.isAwake() && %gui.currGroup == %group)
				%gui.onPickGroup(%gui.currGroup);

		case "clearClasses": //Drops the current list of classes.
			if(isObject(BossBattlesClassGroup))
				BossBattlesClassGroup.delete();
			if(%gui.isAwake())
				%gui.onPickGroup(%gui.currGroup);

		case "newRound": //Calls the new round method.
			%gui.newRound();
			BB_HUD.setVisible(0);
			%gui.bossCount = 0;

			BossBattlesGUI.bossHp = 100;
			BossBattlesGUI.bossHp[0] = 100;
			BossBattlesGUI.bossHp[1] = 100;
			BB_BossArmor1.setPercent(0, BB_BossArmorDmg1);
			BB_BossHealth1.setPercent(100, BB_BossHealthDmg1);
			BB_BossHealthText1.setText(" "); //Set it to nothing
			BB_BossArmor2.setPercent(0, BB_BossArmorDmg2);
			BB_BossHealth2.setPercent(100, BB_BossHealthDmg2);
			BB_BossHealthText2.setText(" "); //Set it to nothing
			BB_Hud_resize();

			if(%a1 !$= "")
				clientCmdBBGUI("setTeam", %a1);

		case "setItemPurchase": //Sets the color of the item purchase buttons.
			%button = %a1 ? BBGUI_ButtonLife : BBGUI_ButtonAkimbo;
			%color = %a2 ? "0 255 0 255" : "255 0 0 255";
			%button.setColor(%color);

		default:
			echo("Error: clientCmdBBGUI - Unknown parameter: " @ %action);
	}
}

// function createTestBBClasses()
// {
	// bossbattlesgui.addclass("Test1", "Seymour Butt", "Has anyone even been so far", 1, 100, "Fast", "Not Real", 0, "dick", "hats");
	// bossbattlesgui.addclass("Test2", "Bill Fuckyou", "Nice guy once you get to know him.",1, 250, "Slow", "N/A", 0, "Nothing");
	// bossbattlesgui.addclass("Test3", "Fred Fucks", "Total asshole once you get to know him.",1, 60, "Average", "One with the force", 0, "ITEM", "Minigun", "Washcloth", "Toothbrush", "Lunchbox");
	// bossbattlesgui.addclass("Test4", "Mister Cheese", "Hello my name is hello my name is hello my name is hello my name", 2, 500, "Very Fast", "Wheeee", 300, "Laziness");
	// bossbattlesgui.addclass("Test5", "Bbbbbbbbb", "bbbbbbbbbbbbbbbbbbb",2, 10, "Slow", "Alt fire to trip and fall", 58000, "Suicide gun");
	// bossbattlesgui.addclass("Test6", "Darth Rude", "DESCRIPTION.",3, "High", "Fast", "OTHER", 0, "STUFF");
	// bossbattlesgui.addclass("Test7", "Evil McEvilstein", "Honk honk.", 3, "Low", "Whaaaaaa", "space to jump", 0, "Hyena gun");
// }

// function createTestBBClasses2()
// {
	// clientCmdBBGUI("addClass", "Test1", "Seymour Butt", "Has anyone even been so far", 1, 100, "Fast", "Not Real", 0, "dick", "hats");
	// clientCmdBBGUI("addClass", "Test2", "Bill Fuckyou", "Nice guy once you get to know him.",1, 250, "Slow", "N/A", 0, "Nothing");
	// clientCmdBBGUI("addClass", "Test3", "Fred Fucks", "Total asshole once you get to know him.",1, 60, "Average", "One with the force", 0, "ITEM", "Minigun", "Washcloth", "Toothbrush", "Lunchbox");
	// clientCmdBBGUI("addClass", "Test4", "Mister Cheese", "Hello my name is hello my name is hello my name is hello my name", 2, 500, "Very Fast", "Wheeee", 300, "Laziness");
	// clientCmdBBGUI("addClass", "Test5", "Bbbbbbbbb", "bbbbbbbbbbbbbbbbbbb",2, 10, "Slow", "Alt fire to trip and fall", 58000, "Suicide gun");
	// clientCmdBBGUI("addClass", "Test6", "Darth Rude", "DESCRIPTION.",3, "High", "Fast", "OTHER", 0, "STUFF");
	// clientCmdBBGUI("addClass", "Test7", "Evil McEvilstein", "Honk honk.", 3, "Low", "Whaaaaaa", "space to jump", 0, "Hyena gun");
// }

if(!isobject(BB_HUD)) //Let's not add the gui until we first get into the game.
{
	exec("./BossBattlesHUDGui.gui");
	BB_HudPos.clear();
	BB_HudPos.add("Off", 0);
	BB_HudPos.add("Top", 1);
	BB_HudPos.add("Center", 2);
	BB_HudPos.add("Bottom", 3);
	BB_HudPos.setSelected(3);
}

function BB_Hud_SetImage(%image, %wrap)
{
	if(!isFile(%image))
		%image = "Add-Ons/Client_BossBattles/" @ %image @ ".png";

	if(!isFile(%image))
		%image = "Add-Ons/Client_BossBattles/bar.png";

	$BBHud_CurrentImage = %image;

	BB_HUDPreview.setBitmap(%image);
	BB_HUDPreview.wrap = %wrap;
	BB_BossHealthBase1.setBitmap(%image);
	BB_BossHealthBase1.wrap = %wrap;
	BB_BossHealth1.setBitmap(%image);
	BB_BossHealth1.wrap = %wrap;
	BB_BossHealthDmg1.setBitmap(%image);
	BB_BossHealthDmg1.wrap = %wrap;
	BB_BossArmor1.setBitmap(%image);
	BB_BossArmor1.wrap = %wrap;
	BB_BossArmorDmg1.setBitmap(%image);
	BB_BossArmorDmg1.wrap = %wrap;

	BB_BossHealthBase2.setBitmap(%image);
	BB_BossHealthBase2.wrap = %wrap;
	BB_BossHealth2.setBitmap(%image);
	BB_BossHealth2.wrap = %wrap;
	BB_BossHealthDmg2.setBitmap(%image);
	BB_BossHealthDmg2.wrap = %wrap;
	BB_BossArmor2.setBitmap(%image);
	BB_BossArmor2.wrap = %wrap;
	BB_BossArmorDmg2.setBitmap(%image);
	BB_BossArmorDmg2.wrap = %wrap;
}

BB_Hud_SetImage($Pref::Client::BB_HUDImage, $Pref::Client::BB_HUDImageWrap);
BB_HUDFont.setValue($Pref::Client::BossBattles::HUD_Font);

function BB_UpdateHUD()
{
	if(BB_HudPos.getText() !$= "Off" && !BB_Hud.isVisible())
		BB_Hud.setVisible(1);
	else if(BB_HudPos.getText() $= "Off" && BB_Hud.isVisible())
		BB_Hud.setVisible(0);
	BB_Hud_resize();
}

if(isPackage(BBGUI_Hud))
	deactivatePackage(BBGUI_Hud);

package BBGUI_Hud
{
	function PlayGui::onWake(%this)
	{
		Parent::onWake(%this);
		PlayGui.add("BB_HUD");
		
		if(!$enableBBHud)
		{
			BB_HUD.setVisible(0);
			schedule(1000, 0, BB_Hud_resize);
		}
	}
	
	function BBHudDoubleBoss::setValue(%this, %bool)
	{
		parent::setValue(%this, %bool);
		
		$pref::Client::BossBattlesGUI::EnableDoubleBoss = %bool;
	}

	function clientCmdBottomPrint(%message, %time, %showBox)
	{
		%stripMessage = stripMLControlChars(%message);
		if(getWords(%stripMessage, 0, 1) $= "Boss Health" && BB_Hud.isVisible() && BB_HudPos.getText() !$= "Off" && BB_HudPos.getText() !$= "")
		{
			%health = strReplace(%stripMessage, "Boss Health(", "");
			%health = strReplace(%stripMessage, "Boss Health (", "");
			%name = getSubStr(%health, 0, strPos(%health, "):"));
			%health = getSubStr(%health, strPos(%health, "):")+3, strLen(%health)-1);
			%health = strReplace(%health, "%", "");

			%hpTxt = getWord(%health, 1);
			%lastWord = getWord(%health, getWordCount(%health)-1);
			if(striPos(%lastWord, "Invincible") >= 0 || striPos(%lastWord, "Invulnerble") >= 0 || striPos(%lastWord, "Immune") >= 0)
			{
				%health = getWords(%health, 0, getWordCount(%health)-2);
				%invincible = 1;
			}

			if(%hpTxt $= "Armor:")
			{
				%health = strReplace(%health, "Armor: ", "");
				%healthText = getWord(%health, 0);
				%armorText = getWord(%health, 1);
				%hpTxt = "Health: " @ %healthText @ "% | Armor: " @ %armorText @ "%";
				%hp = getWord(%health, 0) @ " 100";
				%armorPer = getWord(%health, 1);
			}
			else
			{
				if(%invincible)
					%hpTxt = "Health: " @ getWord(%health, 0) @ "%";
				else
					%hpTxt = "Health: " @ getWord(%health, 1) @ " (" @ getWord(%health, 0) @ "%)";

				%hp = strReplace(getWord(%health, 1), "/", " ");
				%armorPer = 0;
			}

			%percent = getWord(%hp, 0) / getWord(%hp, 1) * 100;
			if(BossBattlesGUI.bossPlayerName[0] $= %name)
			{
				%col = "<color:FF3300>";
				%boss = BossBattlesGUI.bossPlayerClass[0];

				%cHP = BossBattlesGUI.bossHp[0];
				if(%percent >= 0)
				{
					BossBattlesGUI.bossHp[0] = %cHp;
					if(%percent - %cHp > 0)
						%col = "<color:00FF00>";
				}

				BB_BossName1.setText("<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":25>\c1" @ strUpr(%boss) @ " - " @ %name);
				if(!%invincible)
				{
					BB_BossArmor1.setPercent(%armorPer, BB_BossArmorDmg1);
					BB_BossHealth1.setPercent(getWord(%hp, 0) / getWord(%hp, 1) * 100, BB_BossHealthDmg1);
				}
				else
				{
					BB_BossArmor1.setPercent("i", BB_BossArmorDmg1);
					BB_BossHealth1.setPercent("i", BB_BossHealthDmg1);
				}

				BB_BossHealthText1.setText("<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":20>" @ %col @ %hpTxt);
				cancel(BB_BossHealthText1.textBlinkSch);
				BB_BossHealthText1.textBlinkSch = BB_BossHealthText1.schedule(200, setText, "<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":20>" @ %hpTxt);

				cancel(BB_BossHealthText1.textSch);
				BB_BossHealthText1.textSch = BB_BossHealthText1.schedule(1000 * %time, setText, "<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":20><color:B3B3B3>" @ %hpTxt);
			}
			else if(BossBattlesGUI.bossPlayerName[1] $= %name)
			{
				%col = "<color:FF3300>";
				%boss = BossBattlesGUI.bossPlayerClass[1];

				%cHP = BossBattlesGUI.bossHp[1];
				if(%percent >= 0)
				{
					BossBattlesGUI.bossHp[1] = %cHp;
					if(%percent - %cHp > 0)
						%col = "<color:00FF00>";
				}

				if(!BB_HudDoubleBoss.getValue())
				{
					BB_BossName1.setText("<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":25>\c1" @ strUpr(%boss) @ " - " @ %name);
					if(!%invincible)
					{
						BB_BossArmor1.setPercent(%armorPer, BB_BossArmorDmg1);
						BB_BossHealth1.setPercent(getWord(%hp, 0) / getWord(%hp, 1) * 100, BB_BossHealthDmg1);
					}
					else
					{
						BB_BossArmor1.setPercent("i", BB_BossArmorDmg1);
						BB_BossHealth1.setPercent("i", BB_BossHealthDmg1);
					}

					BB_BossHealthText1.setText("<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":20>" @ %col @ %hpTxt);
					cancel(BB_BossHealthText1.textBlinkSch);
					BB_BossHealthText1.textBlinkSch = BB_BossHealthText1.schedule(200, setText, "<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":20>" @ %hpTxt);

					cancel(BB_BossHealthText1.textSch);
					BB_BossHealthText1.textSch = BB_BossHealthText1.schedule(1000 * %time, setText, "<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":20><color:B3B3B3>" @ %hpTxt);
				}
				else
				{
					BB_BossName2.setText("<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":25>\c1" @ strUpr(%boss) @ " - " @ %name);
					if(!%invincible)
					{
						BB_BossArmor2.setPercent(%armorPer, BB_BossArmorDmg2);
						BB_BossHealth2.setPercent(getWord(%hp, 0) / getWord(%hp, 1) * 100, BB_BossHealthDmg2);
					}
					else
					{
						BB_BossArmor2.setPercent("i", BB_BossArmorDmg2);
						BB_BossHealth2.setPercent("i", BB_BossHealthDmg2);
					}

					BB_BossHealthText2.setText("<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":20>" @ %col @ %hpTxt);
					cancel(BB_BossHealthText2.textBlinkSch);
					BB_BossHealthText2.textBlinkSch = BB_BossHealthText2.schedule(200, setText, "<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":20>" @ %hpTxt);

					cancel(BB_BossHealthText2.textSch);
					BB_BossHealthText2.textSch = BB_BossHealthText2.schedule(1000 * %time, setText, "<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":20><color:B3B3B3>" @ %hpTxt);
				}
			}
			else if(%name !$= "")
			{
				%col = "<color:FF3300>";
				%cHP = BossBattlesGUI.bossHp;
				if(%percent >= 0)
				{
					BossBattlesGUI.bossHp = %cHp;
					if(%percent - %cHp > 0)
						%col = "<color:00FF00>";
				}

				if(!BB_HudDoubleBoss.getValue())
				{
					BB_BossName1.setText("<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":25>\c1BOSS - " @ %name);
					if(!%invincible)
					{
						BB_BossArmor1.setPercent(%armorPer, BB_BossArmorDmg1);
						BB_BossHealth1.setPercent(%percent, BB_BossHealthDmg1);
						BossBattlesGUI.bossHp = %percent;
					}
					else
					{
						BB_BossArmor1.setPercent("i", BB_BossArmorDmg1);
						BB_BossHealth1.setPercent("i", BB_BossHealthDmg1);
					}

					BB_BossHealthText1.setText("<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":20>" @ %col @ %hpTxt);
					cancel(BB_BossHealthText1.textBlinkSch);
					BB_BossHealthText1.textBlinkSch = BB_BossHealthText1.schedule(200, setText, "<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":20>" @ %hpTxt);

					cancel(BB_BossHealthText1.textSch);
					BB_BossHealthText1.textSch = BB_BossHealthText1.schedule(1000 * %time, setText, "<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":20><color:B3B3B3>" @ %hpTxt);
				}
				else
				{
					BB_BossName2.setText("<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":25>\c1BOSS - " @ %name);
					if(!%invincible)
					{
						BB_BossArmor2.setPercent(%armorPer, BB_BossArmorDmg2);
						BB_BossHealth2.setPercent(%percent, BB_BossHealthDmg2);
					}
					else
					{
						BB_BossArmor2.setPercent("i", BB_BossArmorDmg2);
						BB_BossHealth2.setPercent("i", BB_BossHealthDmg2);
					}

					BB_BossHealthText2.setText("<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":20>" @ %col @ %hpTxt);
					cancel(BB_BossHealthText2.textBlinkSch);
					BB_BossHealthText2.textBlinkSch = BB_BossHealthText2.schedule(200, setText, "<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":20>" @ %hpTxt);

					cancel(BB_BossHealthText2.textSch);
					BB_BossHealthText2.textSch = BB_BossHealthText2.schedule(1000 * %time, setText, "<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":20><color:B3B3B3>" @ %hpTxt);
				}
			}

			BB_Hud_resize();
			return;
		}
		return Parent::clientCmdBottomPrint(%message, %time, %showBox);
	}

	function disconnectedCleanup(%a)
	{
		BB_HUD.setVisible(0);
		$enableBBHud = false;
		return Parent::disconnectedCleanup(%a);
	}
};
activatePackage(BBGUI_Hud);

function BossBattlesGUI::SetBossInfo(%gui, %num, %name, %boss)
{
	%num = mFloor(%num);

	%gui.bossPlayerName[%num] = %name;
	%gui.bossPlayerClass[%num] = %boss;

	if(%name !$= $Pref::Player::NetName)
		%name = " - " @ %name;
	else
		%name = "";

	if(isObject(%obj = ("BB_BossName" @ %num+1)))
		%obj.setText("<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":25>\c1" @ strUpr(%boss) @ %name);

	if(isObject(%obj = ("BB_BossHealthText" @ %num+1)))
		%obj.setText("<just:center><font:" @ $Pref::Client::BossBattles::HUD_Font @ ":20><color:B3B3B3>Health: 100%");
}

function BossBattlesGUI::CallCMD(%gui, %type, %force)
{
	switch$(%type)
	{
		case "EditingFont":
			%font = BB_HUDFont.lastFont;
			cancel(BB_HUDFont.fontLockSch[0]);
			cancel(BB_HUDFont.fontLockSch[1]);
			cancel(BB_HUDFont.fontLockSch[2]);
			if(%font !$= "")
			{
				BB_HUDFont.fontLockSch[0] = BB_HUDFont.schedule(10000, "setValue", %font);
				BB_HUDFont.fontLockSch[1] = BB_HUDFont.schedule(10000, "setActive", false);
				BB_HUDFont.fontLockSch[2] = BB_HudTextButton.schedule(10000, "setText", "Edit");
			}

		case "EditFont":
			cancel(BB_HUDFont.fontLockSch[0]);
			cancel(BB_HUDFont.fontLockSch[1]);
			cancel(BB_HUDFont.fontLockSch[2]);
			if(BB_HudTextButton.getText() $= "Edit")
			{
				BB_HUDFont.lastFont = BB_HUDFont.getValue();
				BB_HUDFont.setActive(true);
				BB_HudTextButton.setText("Accept");
				BB_HUDFont.fontLockSch[0] = BB_HUDFont.schedule(10000, "setValue", BB_HUDFont.lastFont);
				BB_HUDFont.fontLockSch[1] = BB_HUDFont.schedule(10000, "setActive", false);
				BB_HUDFont.fontLockSch[2] = BB_HudTextButton.schedule(10000, "setText", "Edit");
			}
			else
			{
				BB_HudTextButton.setText("Edit");
				BB_HUDFont.setActive(false);
				%value = BB_HUDFont.getValue();
				if(%force !$= "")
					%value = %force;

				BB_HUDFont.lastFont = %value;
				$Pref::Client::BossBattles::HUD_Font = %value;
				BB_HUDFont.setValue(%value);
			}

		case "ClickWrap":
			BB_Hud_SetImage($BBHud_CurrentImage, BB_HUDWrapCheck.getValue());
			$Pref::Client::BB_HUDImageWrap = BB_HUDWrapCheck.getValue();

		case "ClickPreview":
			%img = BB_HUDSelImages.getRowTextByID(BB_HUDSelImages.getSelectedID());
			BB_HUDSelPreview.setBitmap(%img);

		case "Select":
			%img = BB_HUDSelImages.getRowTextByID(BB_HUDSelImages.getSelectedID());
			BB_Hud_SetImage(%img, BB_HUDSelWrapCheck.getValue());
			$Pref::Client::BB_HUDImageWrap = BB_HUDSelWrapCheck.getValue();
			BB_HUDWrapCheck.setValue(BB_HUDSelWrapCheck.getValue());
			BB_HUDSelWindow.setVisible(false);

		case "OpenSelect":
			if(getFileCount("*.png") != $BBGui_ImageCount)
			{
				$BBGui_ImageCount = getFileCount("*.png");

				BB_HUDSelImages.clear();
				%path = "Add-Ons/Client_*/*.png";
				%count = getFileCount(%path);
				for(%file = findFirstFile(%path); %file !$= ""; %file = findNextFile(%path))
					BB_HUDSelImages.addRow(BB_HUDSelImages.rowCount(), %file);

				%path = "Add-Ons/Script_*/*.png";
				%count = getFileCount(%path);
				for(%file = findFirstFile(%path); %file !$= ""; %file = findNextFile(%path))
					BB_HUDSelImages.addRow(BB_HUDSelImages.rowCount(), %file);

				%path = "base/client/ui/*.png";
				%count = getFileCount(%path);
				for(%file = findFirstFile(%path); %file !$= ""; %file = findNextFile(%path))
					BB_HUDSelImages.addRow(BB_HUDSelImages.rowCount(), %file);
			}

			BB_HUDSelImages.sort(0, 1);
			BB_HUDSelWindow.setVisible(true);
			%gui.pushToBack(BB_HUDSelWindow);

		default:
			warn("BossBattlesGUI::CallCMD() - Unknown command \"" @ %type @ "\"");
	}
}


function BB_Hud_resize()
{
	%gui = BossBattlesGUI;

	%pos = BB_HUD.getPosition();
	%extent = BB_HUD.getExtent();
	%count = mClampF(%gui.bossCount - !BB_HudDoubleBoss.getValue(), 1, 2);
	BB_HUD.resize(getWord(%pos, 0), getWord(%pos, 1), getWord(%extent, 0), (62 * %count));
	BB_BossHUD2.setVisible(%count == 2);
	%extent = BB_HUD.getExtent();
	%pos = BB_HUD.getPosition();

	if(BB_HudPos.getText() $= "Top")
	{
		BB_Hud.position = "0 5";
		BB_HUD.centerX();
	}
	else if(BB_HudPos.getText() $= "Center")
	{
		BB_HUD.resize(getWord(%pos, 0), (getWord(centerPrintDlg.getPosition(), 1) + getWord(centerPrintDlg.getExtent(), 1)), getWord(%extent, 0), getWord(%extent, 1));
		BB_HUD.centerX();
	}
	else //Must be bottom?
	{
		BB_HUD.resize(getWord(%pos, 0), getWord(bottomPrintDlg.getPosition(), 1) - getWord(%extent, 1), getWord(%extent, 0), getWord(%extent, 1));
		BB_HUD.centerX();
	}

	if(getWord(BB_HUD.getPosition(), 1) < 0)
		BB_HUD.shift(0, mAbs(getWord(BB_HUD.getPosition(), 1)) * %count);
}

function GuiBitMapCtrl::setPercent(%this, %percent, %obj)
{
	if(%percent $= "i")
	{
		%color = "0.2 0.2 0.2";

		if(%this.isHealthBar)
			%this.setColor(%color SPC "1");

		return;
	}
	else
	{
		if(%this.percent == %percent)
			return;

		if(%percent < 0)
			%percent = 0;
		if(%percent > 100)
			%percent = 100;
		%perc = %percent / 100;
		%this.percent = %percent;
		%max = getWord(%this.getGroup().extent, 0);
		%max2 = getWord(%this.getGroup().extent, 1);
		%main = %max / 100 * %percent;

		if(%perc <= 1)
			%color = greenToRed(%perc);
		else
			%color = "0 1 0";
	}

	if(%this.isHealthBar)
	{
		%this.extent = %main SPC %max2;
		%this.setColor(%color SPC "1");
		if(isObject(%obj))
			%obj.setDamagePercentTick(%this);
	}
	else if(%this.isArmorBar)
	{
		%this.extent = %main SPC %max2;
		if(isObject(%obj))
			%obj.setDamagePercentTick(%this);
	}
	else
		%this.extent = %main SPC %max2;
}

function GuiBitmapCtrl::setDamagePercentTick(%this, %obj)
{
	if(!%this.isHealthDmgBar && !%this.isArmorDmgBar) return;
	cancel(%this.setDamagePercentTick);
	%x = getWord(%this.position, 0);
	%y = getWord(%this.position, 1);
	%health = getWord(%this.extent, 0);
	%max = getWord(%this.getGroup().extent,0);
	%main = getWord(%obj.extent, 0);
	%this.percent = mFloor(100 / %max * %health);
	%perc = %this.percent;
	if(%main > %max)
		%main = %max;
	if(%main < 0)
		%main = 0;
	%o = mFloor(%health - %main);
	if(%o > 0)
	{
		if(%o > 52)
			%a = -10 * mClampF(%o - 52 / 2, 1, 3);
		else if(%o > 42)
			%a = -6;
		else if(%o > 24)
			%a = -4;
		else if(%o > 5)
			%a = -2;
		else
			%a = -1;
	}
	else
	{
		%this.resize(%x, %y, %main, getWord(%this.getGroup().extent, 1));
		return;
	}

	if(%health + %a > %main)
	{
		%take = %health + %a;
		%this.resize(%x, %y, %take, getWord(%this.getGroup().extent, 1));
	}
	else
	{
		%this.resize(%x, %y, %main, getWord(%this.getGroup().extent, 1));
		return;
	}
	%this.setDamagePercentTick = %this.schedule(50, setDamagePercentTick, %obj);
}

//I don't remember who made this, Port? Well thanks anyway, made some other edits
function rgbToHex(%rgb)
{
	 %r = _compToHex(255 * getWord(%rgb,0));
	 %g = _compToHex(255 * getWord(%rgb,1));
	 %b = _compToHex(255 * getWord(%rgb,2));
	 return %r @ %g @ %b;
}
 
function hexToRgb(%rgb)
{
	 %r = _hexToComp(getSubStr(%rgb,0,2)) / 255;
	 %g = _hexToComp(getSubStr(%rgb,2,2)) / 255;
	 %b = _hexToComp(getSubStr(%rgb,4,2)) / 255;
	 return %r SPC %g SPC %b;
}
 
function _compToHex(%comp)
{
	 %left = mFloor(%comp / 16);
	 %comp = mFloor(%comp - %left * 16);
	 %left = getSubStr("0123456789ABCDEF",%left,1);
	 %comp = getSubStr("0123456789ABCDEF",%comp,1);
	 return %left @ %comp;
}
 
function _hexToComp(%hex)
{
	 %left = getSubStr(%hex,0);
	 %comp = getSubStr(%hex,1);
	 %left = striPos("0123456789ABCDEF",%left);
	 %comp = striPos("0123456789ABCDEF",%comp);
	 if(%left < 0 || %comp < 0)
		  return 0;
	 return %left * 16 + %comp;
}

function greenToRed(%a)
{
	%r = 1;
	%g = 1;
	if(%a >= (1/2))
		%r = mAbs(%a - 1) * 2;
	if(%a < (1/2))
		%g = %a * 2;
	return %r SPC %g SPC "0";
}

//Stolen from RTB, appearently I didn't know these were not default.

//- GuiControl::shift (moves a gui in the X or Y)
function GuiControl::shift(%this,%x,%y)
{
	%this.position = vectorAdd(%this.position,%x SPC %y);
}

//- GuiControl::center (Centers %this inside %parent)
function GuiControl::center(%this,%parent)
{
	%this.centerX(%parent);
	%this.centerY(%parent);
}

//- GuiControl::getCanvasPosition (returns absolute position of a control on the canvas)
function GuiControl::getCanvasPosition(%this)
{
	%targ = %this;
	%x = getWord(%this.position,0);
	%y = getWord(%this.position,1);
	while(isObject(%targ.getGroup()))
	{
		%parent = %targ.getGroup();
		if(%parent.getName() $= "Canvas")
			return %x SPC %y;
			
		%x += getWord(%parent.position,0);
		%y += getWord(%parent.position,1);
		%targ = %parent;
	}
}

//- GuiControl::centerX (Centers %this inside %parent horizontally)
function GuiControl::centerX(%this,%parent)
{
	if(isObject(%parent))
	{
		%maxArea = getWord(%parent.extent,0);
		%width = getWord(%this.extent,0);
		
		%xPosition = (%maxArea/2)-(%width/2);
		if(%parent $= %this.getGroup())
			%this.position = (%xPosition+getWord(%parent.position,0)) SPC getWord(%this.position,1);
		else
			%this.position = (%xPosition+getWord(%parent.getCanvasPosition(),0)) SPC getWord(%this.getCanvasPosition(),1);
	}
	else
	{
		%parent = %this.getGroup();
		%maxArea = getWord(%parent.extent,0);
		%width = getWord(%this.extent,0);
		
		%xPosition = (%maxArea/2)-(%width/2);
		%this.position = %xPosition SPC getWord(%this.position,1);
	}
}

//- GuiControl::centerY (Centers %this inside %parent vertically)
function GuiControl::centerY(%this,%parent)
{
	if(isObject(%parent))
	{
		%maxArea = getWord(%parent.extent,1);
		%height = getWord(%this.extent,1);

		%yPosition = (%maxArea/2)-(%height/2);
		if(%parent $= %this.getGroup())
			%this.position = getWord(%this.position,0) SPC (%yPosition+getWord(%parent.position,1));
		else
			%this.position = getWord(%this.getCanvasPosition(),0) SPC (%yPosition+getWord(%parent.getCanvasPosition(),1));
	}
	else
	{
		%parent = %this.getGroup();
		%maxArea = getWord(%parent.extent,1);
		%height = getWord(%this.extent,1);
		
		%yPosition = (%maxArea/2)-(%height/2);
		%this.position = getWord(%this.position,0) SPC %yPosition;
	}
}